#-----------------------------------------------------------------------------
#
#   Loon - Formations
#
#-----------------------------------------------------------------------------

from __future__ import division
from math import ceil, sqrt
from vector_algebra import vector
from constants import *

#-----------------------------------------------------------------------------

class BoxFormation(object):

	#def __init__(self, spacing, count, centre = vector(0, 0)):
	def __init__(self, units, centre = vector(0, 0)):
		count = len(units)
		spacing = 2 * max(unit.radius for unit in units) + FORMATION_SPACING
		self.centre = centre
		self.spacing = spacing
		self.count = count
		self.ncols = int(ceil(sqrt(count)))
		self.nrows = (count + self.ncols - 1) // self.ncols
	
	def __iter__(self):
		n = self.count
		s = self.spacing
		x = self.centre[0] - s * self.ncols / 2
		y = self.centre[1] + s * self.nrows / 2
		for j in xrange(self.nrows):
			for i in xrange(self.ncols):
				if n <= 0:
					return
				n -= 1
				p = vector(x + i * s, y - j * s)
				yield p

