#-----------------------------------------------------------------------------
#
#   Loon - Shell
#
#-----------------------------------------------------------------------------

import os
import webbrowser
from pygame.locals import *
from albow.dialogs import alert
from albow.resource import get_image, resource_path
from albow.music import MusicOptionsDialog
from humerus.hshell import HShell
from humerus.main_commands import MainCommandScreen
from play_screen import PlayScreen
from game import game

#-------------------------------------------------------------------------------

class MainMenuScreen(MainCommandScreen):

	#bg_color = (72, 16, 1)
	#bg_color = (0, 32, 3)
	bg_image = get_image("title_screen.png")

	def __init__(self, shell):
		MainCommandScreen.__init__(self, shell, with_menu = True)

	menu_items = [
		("Help",             'about',              [K_F1, K_h]),
		("New Game",         'new_game',           [K_n]),
		("Load Game...",     'load_game',          [K_o]),
		("Save Game",        'save_game',          [K_s]),
		("Save Game As...",  'save_game_as',       []),
		("Continue",         'resume_game',        []),
		("Music Options...", 'music_options',      []),
		("Quit",             'quit',               [K_q]),
	]
	
	def position_title_and_menu(self, box):
		box.topleft = (100, 50)

#-------------------------------------------------------------------------------

class Shell(HShell):

	game_title = "Loon"

	def __init__(self, game, options):
		HShell.__init__(self, game, options)
		self.main_menu_screen = MainMenuScreen(self)
		self.play_screen = PlayScreen(self)

	def report_error(self, e):
		alert(str(e))
	
	def about_enabled(self):
		return True
	
	def about_cmd(self):
		path = os.path.abspath(resource_path("html/about.html"))
		print "Shell.about_cmd: path = %r" % path
		webbrowser.open("file://" + path)

	def music_options_cmd(self):
		MusicOptionsDialog().present()
