#-----------------------------------------------------------------------------
#
#   Loon - Status display widget
#
#-----------------------------------------------------------------------------

from albow.widget import Widget
from theme import UI

class StatusDisplay(UI, Widget):

	margin = 5
	value_margin = 100
	line_spacing = 2

	def __init__(self, client, **kwds):
		Widget.__init__(self, width = 250, **kwds)
		self.client = client
	
	def draw(self, surf):
		self.surface = surf
		self.y = self.margin
		self.display_status()
	
	def put_heading(self, label, value = ""):
		self.put(label, value, True)

	def put(self, label, value = "", heading = False):
		y = self.y
		self.put_at(self.margin, y, label, heading)
		if value:
			self.put_at(self.value_margin, y, value, heading)
		self.y = y + self.font.get_height() + self.line_spacing
	
	def put_at(self, x, y, text, heading = False):
		font = self.heading_font if heading else self.font
		buf = font.render(text, True, self.fg_color)
		r = buf.get_rect()
		r.topleft = (x, y)
		self.surface.blit(buf, r)

	def leave_gap(self):
		self.y += 5