#-----------------------------------------------------------------------------
#
#   Loon - Unit building menu widget
#
#-----------------------------------------------------------------------------

from pygame.locals import *
from albow.utils import blit_in_rect
from albow.palette_view import PaletteView
from button_menu import ButtonMenu
from action_widget import ActionWidget
from game import game

class UnitBuildingMenu(ButtonMenu, ActionWidget):
	#  buildable_units    list of Unit subclass
	#  acting_unit        Unit

	item_size = (120, 32)

	def __init__(self, client):
		ButtonMenu.__init__(self, self.item_size, 3, 2)
		self.client = client
	
	def num_items(self):
		return len(self.buildable_units)
	
#	def draw_item(self, surf, i, rect):
#		text = "%s (%s)" % (self.buildable_units[i].title, i+1)
#		buf = self.font.render(text, True, self.fg_color)
#		blit_in_rect(surf, buf, rect, 'l', margin = 5)
#	
#	def click_item(self, i, e):
#		self.invoke_item(i)

	def item_text(self, i):
		return "%s (%s)" % (self.buildable_units[i].title, i + 1)
	
	def invoke_item(self, i):
		unit_class = self.buildable_units[i]
		if unit_class:
			for unit in self.client.world.selected_units:
				unit.build_unit(self.client, unit_class)
			#self.client.enter_site_selection_mode(unit_class)
		else:
			self.client.enter_unit_command_mode()

	def key_down(self, e):
		k = e.key
		if K_KP0 <= k <= K_KP9:
			k = k - K_KP0 + K_0
		i = k - K_1
		if 0 <= i < self.num_items():
			self.invoke_item(i)
			return
		PaletteView.key_down(self, e)
