#-----------------------------------------------------------------------------
#
#   Loon - Factory unit
#
#-----------------------------------------------------------------------------

from __future__ import division
from random import uniform
from albow.resource import get_image
from factory_unit import FactoryUnit
from unit_rover import Rover
from resources import ResourcePack
from constants import *
import game

class Factory(FactoryUnit):

	title = "Factory"
	image = get_image("unit-factory.png")
	radius = 1.0
	buildable_units = [Rover]
	
	initial_resources = dict(
		max_metal = FACTORY_MAX_METAL,
		max_glass = FACTORY_MAX_GLASS,
	)
	
	construction_resources = dict(
		max_metal = FACTORY_REQ_METAL,
	)

	resources_accepted = {'metal', 'glass'}

